# Smart Contract Addresses

This page provides a consolidated registry of deployed smart contract addresses across all Goliath networks.

***

## Goliath Mainnet (Chain 327)

### DEX Contracts

| Contract              | Address                                      | Admin        | Notes                               |
| --------------------- | -------------------------------------------- | ------------ | ----------------------------------- |
| **WXCN**              | `0x1a0Da75ADf091a69E7285e596bB27218D77E17a9` | None         | Fully permissionless wrap/unwrap    |
| **UniswapV2Factory**  | `0x008c99EedA17E193e5F788536234C6b3520B8D15` | Locked (0x0) | Protocol fees permanently disabled  |
| **UniswapV2Router02** | `0xa973c5626eEaF7F482439753953e9B28C6aF3674` | None         | Stateless utility                   |
| **Multicall3**        | `0x88b4BC8e5bd74327B5456466F3f30143986cC1f9` | None         | Permissionless read-only aggregator |

### Bridged Tokens

| Token             | Address                                      | Minter       | Notes                                                                                 |
| ----------------- | -------------------------------------------- | ------------ | ------------------------------------------------------------------------------------- |
| **ETH** (ERC-20)  | `0x9253587505c3B7E7b9DEE118AE1AcB53eEC0E4b6` | BridgeMint   | Bridged from Ethereum Mainnet                                                         |
| **USDC** (ERC-20) | `0xC8410270bb53f6c99A2EFe6eD3686a8630Efe22B` | BridgeMint   | Bridged from Ethereum Mainnet                                                         |
| **BTC** (ERC-20)  | `0xDf30632AC69E3AD2A96D7538d5B874E0ddA4101E` | Locked (0x0) | **Non-functional** - owner locked to zero address, totalSupply=0. Needs redeployment. |

### Bridge Contracts

| Contract       | Address                                      | Admin           | Notes                           |
| -------------- | -------------------------------------------- | --------------- | ------------------------------- |
| **BridgeMint** | `0x1d14ae13ca030eb5e9e2857e911af515cf5ffff2` | Owner + Relayer | Mints bridged tokens on Goliath |

BridgeMint roles:

* **Owner** (`0xE708B7...3640`): `setRelayer()`, `setRegisteredToken()`, `transferOwnership()`
* **Relayer** (`0x90F269...f6cB`): `mint()`, `mintFromPool()`

### Staking Contracts

| Contract            | Address                                      | Admin              | Notes                           |
| ------------------- | -------------------------------------------- | ------------------ | ------------------------------- |
| **StakedXCNDirect** | `0xA553a603e2f84fEa6c1fc225E0945FE176C72F74` | Owner (OZ Ownable) | UUPS upgradeable liquid staking |

StakedXCNDirect owner privileges:

* `setRewardRate()`, `setTreasury()`, `setFeePercent()`, `fund()`
* `pause()` / `unpause()`, UUPS `upgradeTo()`, `transferOwnership()`

### Other Contracts

| Contract           | Address                                      | Admin              | Notes             |
| ------------------ | -------------------------------------------- | ------------------ | ----------------- |
| **FlashArbitrage** | `0x4de29616f7be2bc44D9dfF23abc5Fcb5804DF8B9` | Owner (OZ Ownable) | Arbitrage utility |

***

## Ethereum Mainnet (Chain 1)

These contracts support cross-chain bridge operations between Ethereum and Goliath.

| Contract       | Address                                      | Admin           | Notes                         |
| -------------- | -------------------------------------------- | --------------- | ----------------------------- |
| **BridgeLock** | `0xa9fd64b5095d626f5a3a67e6db7fb766345f8092` | Owner + Relayer | Locks assets on Ethereum side |

BridgeLock roles:

* **Owner** (`0xE708B7...3640`): `setRelayer()`, `emergencyWithdraw()`, `transferOwnership()`
* **Relayer** (`0x90F269...f6cB`): `release()`, `releaseNative()`

***

## Goliath Testnet (Chain 8901)

### DEX Contracts

| Contract              | Address                                      |
| --------------------- | -------------------------------------------- |
| **WXCN**              | `0x88A07F7BBb61A2945D8Ac541461fc62efb1F4066` |
| **UniswapV2Factory**  | `0x561B0342878bcdeF1a7E7D9BA7654B3C84A81819` |
| **UniswapV2Router02** | `0x1D6B8ad12C72893f89844418DC03999298D9ABF4` |
| **Multicall3**        | `0xF912C1ad454aaaE03A1d72C53702F3dc0B4fcb69` |

### Tokens

| Token    | Address                                      | Decimals |
| -------- | -------------------------------------------- | -------- |
| **ETH**  | `0xEd02AA7dd3f105EDab8702D859781CAfF111324b` | 18       |
| **BTC**  | `0x8b2a7658acD9CA5b4e207F94a0101598c7B678F8` | 8        |
| **USDC** | `0x4BE65Dce1D79B8728485B759eE06cC8053E824F4` | 6        |
| **USDT** | `0x03cDCCa25A46Bc5F3F484096217de52C8c417c9D` | 6        |

### Bridge Contracts

| Contract                | Network          | Address                                      |
| ----------------------- | ---------------- | -------------------------------------------- |
| **Bridge**              | Ethereum Sepolia | `0xA9FD64B5095d626F5A3A67e6DB7FB766345F8092` |
| **Bridge**              | Goliath Testnet  | `0x2c1d218B5a97a26D144ffd12d5C813590f93FFEB` |
| **Sepolia XCN (ERC20)** | Ethereum Sepolia | `0x7a8adc542A35c93da263A188367F4bF4c445B8E9` |

### Staking Contracts

| Contract                 | Network          | Address                                      |
| ------------------------ | ---------------- | -------------------------------------------- |
| **stXCN Proxy**          | Goliath Testnet  | `0x18da8D438a030B530Aba59Ae0aD1942bEB14a9cE` |
| **stXCN Implementation** | Goliath Testnet  | `0xb351e224466F45fe652F7Dfd577dAB7A6717aBfC` |
| **BridgeStakingAdapter** | Goliath Testnet  | `0x899fd7C568e9040F4320e3f23B05DC340ec2aA78` |
| **Sepolia Staking**      | Ethereum Sepolia | `0xc50B664BA11F5558b8FF7358bb7C576542655D54` |

***

## Verification

All contract addresses can be verified on the respective block explorers:

* **Goliath Mainnet Explorer:** <https://explorer.goliath.net>
* **Goliath Testnet Explorer:** <https://testnet.explorer.goliath.net>
* **Ethereum Mainnet:** <https://etherscan.io>
* **Ethereum Sepolia:** <https://sepolia.etherscan.io>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.goliath.net/reference/contracts.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
